Subject: Re: [PATCH net-next 2/4] mlx4: xdp: Allow raising MTU up to one page minus eth and vlan hdrs

From: Alexei Starovoitov <[email-masked]>
Date: Fri, 2 Dec 2016 16:53:09 -0800

On 12/2/16 4:38 PM, Eric Dumazet wrote:
> On Fri, 2016-12-02 at 15:23 -0800, Martin KaFai Lau wrote:
>> When XDP prog is attached, it is currently limiting
>> MTU to be FRAG_SZ0 - ETH_HLEN - (2 * VLAN_HLEN) which is 1514
>> in x86.
>>
>> AFAICT, since mlx4 is doing one page per packet for XDP,
>> we can at least raise the MTU limitation up to
>> PAGE_SIZE - ETH_HLEN - (2 * VLAN_HLEN) which this patch is
>> doing.  It will be useful in the next patch which allows
>> XDP program to extend the packet by adding new header(s).
>>
>> Signed-off-by: Martin KaFai Lau <[email-masked]>
>> ---
>
> Have you tested your patch on a host with PAGE_SIZE = 64 KB ?
>
> Looks XDP really kills arches with bigger pages :(

I'm afraid xdp mlx[45] support was not tested on arches
with 64k pages at all. Not just this patch.
I think people who care about such archs should test?
Note page per packet is not a hard requirement for all drivers
and all archs. For mlx[45] it was the easiest and the most
convenient way to achieve desired performance.
If there are ways to do the same performance differently,
I'm all ears :)